unit MiniLed_Main;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.Filter.Effects, FMX.Effects, FMX.StdCtrls, FMX.Objects, FMX.Ani,
  System.Actions, FMX.ActnList, FMX.Edit, FMX.Layouts, FMX.Memo, Xml.xmldom,
  Xml.XMLIntf, Xml.adomxmldom, Xml.XMLDoc, FMX.Gestures;

type

  RMap = record
     MinX: double;
     MinY: double;
     MaxX: double;
     MaxY: double;
     Width: double;
     Height: double;
     MapName: String;
  end;

  RODD = record
     MinX: double;
     MinY: double;
     MaxX: double;
     MaxY: double;
     ODD: string;
  end;

  TMainForm = class(TForm)
    Image: TImage;
    b_plus: TButton;
    ShadowEffect1: TShadowEffect;
    Button2: TButton;
    ShadowEffect2: TShadowEffect;
    XMLDocument: TXMLDocument;
    ProgressBar: TProgressBar;
    l_Progress: TLabel;
    GlowEffect1: TGlowEffect;
    Edit1: TLabel;
    GlowEffect2: TGlowEffect;
    Memo1: TMemo;
    b_Minus: TButton;
    ShadowEffect3: TShadowEffect;
    Button1: TButton;
    ShadowEffect4: TShadowEffect;
    GestureManager1: TGestureManager;
    Button3: TButton;
    ShadowEffect5: TShadowEffect;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ImageResize(Sender: TObject);
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Single);
    procedure b_plusClick(Sender: TObject);
    procedure b_MinusClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    Bm: Fmx.Graphics.TBitmap;
//    G: Graphics;
    LastX,LastLocalX: Single;
    LastY,LastLocalY: Single;
    RefX: Single;
    RefY: Single;
    aX,aY: Single;
    MMoves: integer;
    FGPSFixed: boolean;
    PreparingMove: boolean;
    BmMoving: boolean;
    BmPrepared: boolean;
    procedure set_GPSFixed(const Value: boolean);
//    FOnSelectJPRL: EventHandler;
  public
    m_Cnt: integer;
//    objParser: GpsToolsNET.NmeaParser;
    GpsOn: boolean;
    aScale: System.Double;
    aJTSK: boolean;
//    DETshp: GpsShapeNET.ShapeFile;
//    EDITshp: GpsShapeNET.ShapeFile;
    iLHC: integer;
    iOddeleni: integer;
    iDilec: integer;
    iPorost: integer;
    iSkupina: integer;
    Moving: boolean;
    ActiveTool: integer;
    ActiveSubTool: integer;
    Fix: boolean;
    Rotate: boolean;
    ToolsMoving: boolean;
    ToolsVisible: boolean;
    Maps: Array of RMap;
    Odds: Array of RODD;
    iLastOdd: integer;
    Oddeleni,Dilec,Porost,Skupina: string;
    CloseIsVisible: boolean;
    OddListExists: boolean;
    White: boolean;
//    ObjShape: GpsShapeNET.Shape;
//    ObjMapShape: GpsViewNET.MapShape;
//    aPosition: GpsToolsNET.Position;
    Error: integer;
    CenterX: System.Double;CenterY: System.Double;
    RealScale: System.Double;
    Scale1: System.Double;
    MinX: System.Double;MinY: System.Double;MaxX: System.Double;MaxY: System.Double;
    MultX: System.Double;MultY: System.Double;
    AddX: System.Double;AddY: System.Double;
    GpsX,GpsY: double;
    MapDirectory: string;
    Reviews: Array of Integer;
    LastReview: integer;
    BColor: TAlphaColor;
    { Public declarations }
     procedure LoadProject(aFileName: string);
    procedure LoadMap(aFileName,aExt: string);
    procedure LoadDET(aFileName,aOddName: string);
    procedure LoadEdit(aFileName: string);
    procedure ShowTheForest;
    procedure CHeckActiveTool(NewActive: integer);
    function  GetExecutablePath : String;
    function  GetAbsolutePath(aRootPath,aRelativePath: string): string;
    function  FindLayerPath(aLayer: string): string;
    function  FindLayerExt(aLayer: string): string;
    function  StopReviews: integer;  // stopne zobrazeni a vrati volnou pozici
    procedure Review(compact: boolean);
    procedure Drawgps;
    procedure CHangeProjection(_X,_Y,_Scale: double);
    procedure ChangeProjectionByFirstMapTile;
    procedure CHangeProjectionByRect(X1,Y1,X2,Y2: double);
    procedure OnSelectFile(const S: string);
    function GetModelX(aPageX: Single): System.Double;
    function GetModelY(aPageY: Single): System.Double;
    function  GetPageX(aModelX: double): single;
    function  GetPageY(aModelY: double): single;
    function GetModelLength(aPageLength: single): System.Double;
    function  GetPageLength(aModelLength: double): single;
    property GPSFixed: boolean read FGPSFixed write set_GPSFixed;
//    property OnSelectJPRL: EventHandler add FOnSelectJPRL remove FOnSelectJPRL;
  end;


var
  MainForm: TMainForm;

implementation
uses
   Elements, //-
//   e_Class,  //-
//   u_Props,  //+
//   u_String, //+
//   TestUnit,
   System.Typinfo,
   t_XFileDialog,
   System.IOUtils;

{$R *.fmx}

procedure TMainForm.b_MinusClick(Sender: TObject);
var
   DestRect,SrcRect: TRectF;
   i: integer;
   X1,Y1,X2,Y2: double;
   sc, DestSc: double;
   srcScale,Step: double;
begin
   Bm := TBitmap.Create(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//   Bm.BitmapScale := Image.Bitmap.BitmapScale;
   Bm.CopyFromBitmap(Image.Bitmap);
   X1 := MinX;
   Y1 := MaxY;
   X2  := MaxX;
   Y2  := MinY;
   SrcScale := RealScale;
   Sc := 1;
   DestSc := 1.5;
   Step := 0.05;
   While Sc < DestSc do
   begin
      Sc := Sc + Step;
      ChangeProjection(CenterX,CenterY,SrcScale * Sc);
      SrcRect  := TRectF.Create(0,0,Bm.Width,Bm.Height);
      DestRect := TRectF.Create(GetPageX(X1),GetPageY(Y1),GetPageX(X2),GetPageY(Y2));
      Image.Bitmap.Canvas.BeginScene;
      Image.Bitmap.Canvas.Clear(BColor);
      Image.Bitmap.Canvas.DrawBitmap(Bm,SrcRect,DestRect,1);
      Image.Bitmap.Canvas.EndScene;
      Application.ProcessMessages;
   end;
   BM.DisposeOf;
   //G := Graphics.FromImage(PictureBox1.Image);
   ChangeProjection(CenterX,CenterY,SrcScale * 1.5);
   Review(false);
end;

procedure TMainForm.b_plusClick(Sender: TObject);
var
   DestRect,SrcRect: TRectF;
   i: integer;
   X1,Y1,X2,Y2: double;
   sc, DestSc: double;
   srcScale,Step: double;
begin
   Bm := TBitmap.Create(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
//   Bm.BitmapScale := Image.Bitmap.BitmapScale;
   Bm.CopyFromBitmap(Image.Bitmap);
   X1 := MinX;
   Y1 := MaxY;
   X2  := MaxX;
   Y2  := MinY;
   SrcScale := RealScale;
   Sc := 1;
   DestSc := 1.5;
   Step := 0.1;
   While Sc < DestSc do
   begin
      Sc := Sc + Step;
      ChangeProjection(CenterX,CenterY,SrcScale / Sc);
      SrcRect  := TRectF.Create(0,0,Bm.Width,Bm.Height);
      DestRect := TRectF.Create(GetPageX(X1),GetPageY(Y1),GetPageX(X2),GetPageY(Y2));
      Image.Bitmap.Canvas.BeginScene;
      Image.Canvas.Clear(BColor);
      Image.Bitmap.Canvas.DrawBitmap(Bm,SrcRect,DestRect,1);
      Image.Bitmap.Canvas.EndScene;
      Application.ProcessMessages;
   end;
   BM.DisposeOf;
   //G := Graphics.FromImage(PictureBox1.Image);
   ChangeProjection(CenterX,CenterY,SrcScale / 1.5);
   Review(false);
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
//   Application.Terminate;
   CLose;
end;

procedure TMainForm.Button2Click(Sender: TObject);
var
   XD: TXFileDialog;
begin
   XFileDialog.Filter := '.opx';
   XFileDialog.Directory := '/';
   XFileDialog.ed_Caption.Text := 'Vbr souboru projektu';
   XFileDialog.OnSelect := OnSelectFile;
   XFileDialog.Show;
//   XD := TXFileDialog.Create(Application);
//   XD.Directory := '/';
//   XD.ed_Caption.Text := 'Vbr souboru projektu';
//   XD.Filter := '.opx';
//   XD.ShowModal(procedure(ModalResult: TModalResult)
//   begin
//     if ModalResult = mrOK then
//     begin
//     // if OK was pressed and an item is selected, pick it
//        edit1.Text := XD.FileName ;
//     end
//     else
//        edit1.Text := '';
//     XD.DisposeOf;
//   end);
//   if Edit1.Text <> '' then
//      LoadProject(Edit1.Text);
//
end;

procedure TMainForm.Button3Click(Sender: TObject);
var
   P1,P2: TPointF;
begin
   P1 := TPointF.Create(0,0);
   P2 := TPointF.Create(Image.Bitmap.Width - 2,Image.Bitmap.Height - 2);
   Image.Bitmap.Canvas.DrawLine(P1,P2,1);
end;

procedure TMainForm.CHangeProjection(_X, _Y, _Scale: double);
var
   Center_X, Center_Y,W,H: Single;
begin
   Edit1.Text := '1 : ' + IntToStr(Round(_Scale));
   CenterX   := _X;
   CenterY   := _Y;
   RealScale := _Scale;
   W := Image.Width;
   H := Image.Height;
   Center_X := W / 2;
   Center_Y := H / 2;
   MultX := RealScale/5333; //Resolution.x; dpi / size of inch in mm * 1000
   MultY := MultX;
   AddX := CenterX - (Center_X * MultX);
   AddY := CenterY + (Center_Y * MultY);
   MinX := GetModelX(0);
   MinY := GetModelY(H);
   MaxX := GetModelX(W);
   MaxY := GetModelY(0);
   if _Scale = Scale1 then
      aScale := 1
   else
      aScale := 2;
end;

procedure TMainForm.ChangeProjectionByFirstMapTile;
var
   MapRec : RMap;
   S: string;
   //G: Graphics;
   bm1: FMx.Graphics.TBitmap;
   DestRect,SrcRect: TRectF;
   rX,rY: integer;
   x1,y1,x2,y2: double;
   wi,hi: single;
   wd,hd: double;
begin
   if Length(Maps) < 1 then exit;
   MapRec := Maps[0];
   //MessageBox.Show(S);
   S := MapDirectory + MapRec.MapName;
   //edit1.Text := Edit1.Text + ' BM1 '+ S;
   try
//   MessageBox.Show(S);
//   exit;
   //if BM <> nil then
   //  BM.Dispose;
//   ShowMessage('load bmp');
   Bm1 := FMX.Graphics.TBitmap.CreateFromFile(S);
   Image.Bitmap.Canvas.BeginScene;
//   ShowMessage('clear');
   Image.Bitmap.Canvas.Clear(BColor);
   aScale := 1;
   SrcRect.Create(0,0,Bm1.Width,Bm1.Height);
   DestRect.Create(RefX,RefY,RefX + (Bm1.Width / Image.Canvas.Scale),RefY + (Bm1.Height / Image.Canvas.Scale));

//   ShowMessage('draw');

   Image.Bitmap.Canvas.DrawBitmap(Bm1,SrcRect,DestRect,100);
   Image.Bitmap.Canvas.EndScene;
//   PaintBox.BitmapChanged;
   wi := Image.Width;
   hi := Image.Height;
   if BM1.Width < wi then
      wi := BM1.Width;
   if BM1.Height < hi then
      hi := BM1.Height;
   WD := MapRec.MaxX - MapRec.MinX;
   HD := MapRec.MaxY - MapRec.MinY;
   x1 := MapRec.MinX;
   Y2 := MapRec.MaxY;
   Y1 := Y2 - hD / BM1.Height * hi;
   x2 := X1 + wd / BM1.Width  * wi;
   Bm1.DisposeOf;
//   ShowMessage('Chng proje');
   CHangeProjectionByRect(X1,Y1,X2,Y2);
   Scale1 := RealScale;
   //PictureBox1.Image := System.Drawing.Bitmap.Create(S);
//   ShowMessage('After Chng proje');
   finally
//      ShowMessage('ups');
   end;
end;

procedure TMainForm.CHangeProjectionByRect(X1, Y1, X2, Y2: double);
var
   _x,_y: double;
   _Scale: double;
   ScaleX: double;
   ScaleY: double;
   dX,dY: double;
begin
   dX := X2 - X1;
   dY := Y2 - Y1;
   try
     ScaleX := dX/(Image.Width/5333);
     ScaleY := dY/(Image.Height/5333);
     if ScaleX > ScaleY then _Scale := ScaleX
                        else _Scale := ScaleY;
     _x :=  X1 + dX/2;
     _y :=  Y1 + dY/2;
     ChangeProjection(_X,_Y, _Scale)
   except
   end
end;

procedure TMainForm.CHeckActiveTool(NewActive: integer);
begin

end;

procedure TMainForm.Drawgps;
begin

end;

function TMainForm.FindLayerExt(aLayer: string): string;
var
  i: integer;
  n,DE: IXMLNode;
  s: string;
begin
  Result := '';
  DE := XMLDocument.DocumentElement;
  for i := 0 to DE.ChildNodes.Count - 1 do
  begin
     N := DE.ChildNodes[i];
     s := N.ChildNodes['Layer'].Text;
     if s = aLayer then
     begin
        result := N.ChildNodes['Ext'].Text;
     end;
  end;
end;

function TMainForm.FindLayerPath(aLayer: string): string;
var
  i: integer;
  n,DE: IXMLNode;
  s: string;
begin
  Result := '';
  DE := XMLDocument.DocumentElement;
  for i := 0 to DE.ChildNodes.Count - 1 do
  begin
     N := DE.ChildNodes[i];
     s := N.ChildNodes['Layer'].Text;
     if s = aLayer then
     begin
        result := N.ChildNodes['File'].Text;
     end;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
   i: integer;
begin
   Moving := false;
   bmMoving := false;
   Fix := false;
   GPSFixed := false;
   ToolsMoving := false;
   ToolsVisible := true;
   Rotate := false;
   iLastOdd := -1;
   BColor := TAlphaColors.Black;
   Image.Bitmap.Resize(Round(Image.Width * Image.Canvas.Scale),Round(Image.Height * Image.Canvas.Scale));
   Image.Bitmap.Canvas.BeginScene;
   Image.Bitmap.Canvas.Clear(BColor);
   Image.Bitmap.Canvas.EndScene;
//   Image.Bitmap := TBitmap.Create(Round(Image.Width {* Image.Scene.GetSceneScale}),Round(Image.Height{ * Image.Scene.GetSceneScale}));
//   Image.Bitmap.BitmapScale := 1;
   Edit1.Text := IntToStr(Round(Image.AbsoluteWidth))+'x'+IntToStr(Round(Image.AbsoluteHeight))+'('+IntToStr(Round(Width))+'x'+IntToStr(Round(Height))+') scale Scene: '+IntToStr(Round(Image.Scene.GetSceneScale))+' canvas: '+IntToStr(Round(Image.Canvas.Scale));
//   iScene.
   RefX := 0;
   RefY := 0;
   LastX := 0;
   LastY := 0;
   aScale := 1;
   ActiveTool := 0;
   SetLength(Reviews,20);
   for i  := 0 to Length(Reviews) - 1 do Reviews[i] := 0;

   LastReview := 0;
   aJTSK := false;
   Application.ProcessMessages;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
//   Edit1.Text := 'PaintBox '+ IntToStr(Round(PaintBox.Width))+'x'+IntToStr(Round(PaintBox.Height));
end;

function TMainForm.GetAbsolutePath(aRootPath, aRelativePath: string): string;
begin
   if aRootPath = '' then
      aRootPath := GetExecutablePath;
   result :=  System.IOUtils.TPath.Combine(aRootPath, aRelativePath);
end;

function TMainForm.GetExecutablePath: String;
begin
   result := Paramstr(0);
end;

function TMainForm.GetModelLength(aPageLength: single): System.Double;
begin
  Result:= aPageLength * MultX;
end;

function TMainForm.GetModelX(aPageX: single): System.Double;
begin
   Result:= MultX*aPageX + AddX ;
end;

function TMainForm.GetModelY(aPageY: single): System.Double;
begin
   Result:=  AddY-(MultY*aPageY);
end;

function TMainForm.GetPageLength(aModelLength: double): single;
begin
  result:= 0;
  if MultX = 0 then exit;
  try
    Result:= round(aModelLength / MultX);
{    Result:= round(ModelLength / UniMult); }
  except
  end
end;

function TMainForm.GetPageX(aModelX: double): single;
begin
  result:= 0;
  if MultX = 0 then exit;
  try
   Result:= (aModelX - AddX)/MultX;
  except
  end
end;

function TMainForm.GetPageY(aModelY: double): single;
begin
  result:= 0;
  if MultY = 0 then exit;
  try
   Result:= (AddY-aModelY)/MultY;
  except
  end
end;

procedure TMainForm.ImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
var
   S: string;
   i, ii: integer;
//   aShape: GpsShapeNET.Shape;
//   aDataRecord: GpsShapeNET.DataRecord;
//   aDataField:  GpsShapeNET.DataField;
   JPRLChecked: boolean;
   JPRLResult: boolean;


begin
   JPRLChecked := false;
   JPRLResult := false;
//   if Fix then
//       pb_fix_Click(nil,nil);
//
//   aPosition.Easting := GetModelX(e.x);
//   aPosition.Northing := GetModelY(e.Y);
//   //if ObjPosition. then
//   if c_Action.SelectedIndex < 0 then
//      c_Action.SelectedIndex := 0;
//   case c_Action.SelectedIndex of
//      0:
//      begin
//         l_Coords.Text := aPosition.LongitudeString(0) + ', ' + aPosition.LatitudeString(0);
//      end;
//      1:
//      begin
//         S := '0.##';
//         l_Coords.Text := 'x:'+FormatFloat(S,aPosition.Easting)+' y:'+FormatFloat(S,aPosition.Northing);
//      end;
//      2:
//      begin
//         CheckJPRL;
//      end;
//   end;
   i := ActiveTool;//c_Action.SelectedIndex;
   if i < 0 then i := 0;
   case i of
      0: // zmena polohy
      begin
         PreparingMove := true;
//         Memo1.Lines.Add('down --------') ;
         Bm := TBitmap.Create(Round(Image.Bitmap.Width),Round(Image.Bitmap.Height));
         Bm.CopyFromBitmap(Image.Bitmap);
         //G := Graphics.FromImage(PictureBox1.Image);
         LastX := X;
         LastY := Y;
         LastLocalX := X;
         LastLocalY := Y;
         PreparingMove := false;
         BmPrepared := true;
      end;
      1: //vyber plochy
      begin
//         if CheckJPRL and Assigned(FOnSelectJPRL) then
//            //FOnSelectJPRL(aOddeleni,aDilec,aPorost,aPSK);
//            FOnSelectJPRL(Self, nil);
      end;
      2: // editace linie
      begin
         ii := ActiveSubTool;
         case ii of
            0:
            begin
//               objShape.NewNode(-1);
//               objShape.Position := objPosition;
            end;
            1:
            begin

            end;
            2:
            begin

            end;
         end;

//         map1.Update();
      end;
   end;
   // Center on mouse click

   //firstPos = null;
end;

procedure TMainForm.ImageMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Single);
var
   dX,sY: integer;
   _X,_Y: double;
   S: string;
   i: integer;
   SrcRect,DestRect: TRectF;
begin
   if not BmPrepared then  exit;

   if BmMoving then exit;
   BmMoving := true;
   i := ActiveTool;//c_Action.SelectedIndex;
   case i of
      0:
      begin
      try
      if PreparingMove then exit;

      if (LastLocalX = x) and (LastLocalY = Y)  then exit;
//      Memo1.Lines.Add('Move');
      LastLocalX := X;
      LastLocalY := Y;
      _X := GetModelX(x);
      _Y := GetModelY(Y);
//      S := '0.##';
//      l_Coords.Text := 'x:'+FormatFloat(S,_X)+' y:'+FormatFloat(S,_Y);

      //l_xy.Text := e.x.ToString + ',' + e.Y.ToString;
      //G.Clear(0);
      //G.Clear(Color.WhiteSmoke);
      Image.Bitmap.Canvas.BeginScene;
      Image.Bitmap.Canvas.Clear(BColor);
      aX := X - LastX;
      aY := Y - LastY;
//      Image.Bitmap.Canvas.DrawLine(TPointF.Create(LastLocalX,LastLocalY),TPointF.Create(X,Y),100);
//      LastLocalX := X;
//      LastLocalY := Y;
      SrcRect.Create(0,0,Bm.Width,Bm.Height);
      DestRect.Create(aX,aY,aX + (Bm.Width / Image.Canvas.Scale),aY + (Bm.Height / Image.Canvas.Scale));
      Image.Bitmap.Canvas.DrawBitmap(Bm,SrcRect,DestRect,100);
      Image.Bitmap.Canvas.EndScene;
      finally

      end;
      end;
   end;
   BmMoving := false;
end;

procedure TMainForm.ImageMouseUp(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Single);
var
   _X,_Y: double;
begin
   if ActiveTool <> 0 then exit;

//   Memo1.Lines.Add( 'Up') ;
   Bm.DisposeOf;
   BmPrepared := false;
   RefX := RefX + aX;
   RefY := RefY + aY;
   _X := GetModelLength(aX);
   _Y := GetModelLength(aY);
   CHangeProjection(CenterX - _X,CenterY + _Y, RealScale);
   //G.Dispose;
   LastX := 0;
   LastY := 0;
   Review(false);
   bmMoving := false;
   PreparingMove := false;
end;

procedure TMainForm.ImageResize(Sender: TObject);
begin
   Image.Bitmap.Resize(Round(Image.Width * Image.Canvas.Scale),Round(Image.Height * Image.Canvas.Scale));
//   Image.Bitmap.Width := Round(Image.Width);
//   Image.Bitmap.Height := Round(Image.Height);
   CHangeProjection(CenterX,CenterY,RealScale);
   Review(false);
//   Edit1.Text := 'resize '+IntToStr(Round(Image.Width))+'x'+IntToStr(Round(Image.Height));
end;

procedure TMainForm.LoadDET(aFileName, aOddName: string);
begin

end;

procedure TMainForm.LoadEdit(aFileName: string);
begin

end;

procedure TMainForm.LoadMap(aFileName, aExt: string);
var
   S,SS: string;
   i: integer;
   MDCount: integer;
   MapRec : RMap;
//   objRow : DataRow;
   n,DE: IXMLNode;
begin
   if aFileName = ''  then
      exit;
   MapDirectory := IncludeTrailingPathDelimiter(aFileName);
   S := MapDirectory + 'Tiles.xml';
   if not (System.IOUtils.TFile.Exists(S)) then
   begin
      ShowMessage('Soubor '+ S + ' neexistuje!');
      exit;
   end
   else
   begin
      l_Progress.Text := 'ten mapovho souboru ...';
      // cteme dataset
      XMLDOcument.Active := false;
      XMLDocument.FileName := S;
      XMLDocument.Active := true;
      DE := XMLDocument.DocumentElement;
      MDCount := DE.ChildNodes.Count;
      SetLength(Maps, MDCount);
      ProgressBar.Min := 0;
      ProgressBar.Max := MDCount - 1;
      for i  := 0 to MDCount - 1 do
      begin
         N := DE.ChildNodes[i];
         ProgressBar.Value := i;
         SS := N.ChildNodes['TILE'].Text;
         l_Progress.Text := 'Pprava mapy ' + SS;
         Application.ProcessMessages;
         MapRec.MinX := StrToIntDef(N.ChildNodes['minx'].Text,0);
         MapRec.MinY := StrToIntDef(N.ChildNodes['miny'].Text,0);
         MapRec.MaxX := StrToIntDef(N.ChildNodes['maxx'].Text,0);
         MapRec.MaxY := StrToIntDef(N.ChildNodes['maxy'].Text,0);
         MapRec.MapName :=  SS + '.' + aExt;
         MapRec.Width := (MapRec.MaxX - MapRec.MinX);
         MapRec.Height := (MapRec.MaxY - MapRec.MinY);
         Maps[i] := MapRec;
      end;
   end;
end;

procedure TMainForm.LoadProject(aFileName: string);
var
   S,sDir,sMap,sDET,sEdit,sOdd,sMapExt: string;
   i: integer;
begin
//   Refresh;
   Application.ProcessMessages;
   OddListExists := false;
//  S := GetAbsolutePath('',aFileName);
   S := aFileName;
   sDir := TPath.GetDirectoryName(S);
   //MessageBox.Show('Before read');
   XMLDocument.FileName := S;
   XMLDocument.Active := true;
   //MessageBox.Show('After read');
   sMap := FindLayerPath('Map');
   sMapExt := FindLayerExt('Map');
   sDET := FindLayerPath('Det');
   sEdit := FindLayerPath('Edit');
   sOdd := '';
   if sMap <> '' then
      sMap := GetAbsolutePath(sDir,sMap);
   if sDET <> '' then
   begin
      sDet := GetAbsolutePath(sDir,sDET);
      sOdd := System.IOUtils.TPath.ChangeExtension(sDet,'.odx');
   end;
   if sEdit <> '' then
   begin
      sEdit := GetAbsolutePath(sDir,sEdit);
   end;
   l_Progress.Visible := true;
   ProgressBar.Visible := true;
   LoadDET(sDET,sOdd);
   LoadMap(sMap,sMapExt);
   LoadEdit(sEdit);
   l_Progress.Visible := false;
   ProgressBar.Visible := false;
   ChangeProjectionByFirstMapTile;
//   ShowMessage('BeforeReview');
   Review(false);
end;

procedure TMainForm.OnSelectFile(const S: string);
begin
   Edit1.Text := S;
   //XFileDialog.Close;
   Application.ProcessMessages;
   LoadProject(S);
end;

procedure TMainForm.Review(compact: boolean);
var
   i: integer;
   Revi: integer;
   Maprec: RMap;
   S: string;
   bm1: TBitmap;
   DestRect,SrcRect: TRectf;
begin
   Revi := StopReviews;
   Reviews[Revi] := 1;
   //G.Clear(System.Drawing.Color.WhiteSmoke);
    Application.ProcessMessages;
    if Compact then
    begin
       Image.Bitmap.Canvas.BeginScene;
       Image.Bitmap.Canvas.Clear(BColor);
    end;
    for i := 0 to Length(Maps) - 1 do
    begin
       if Reviews[Revi] = 2 then
       begin
          Reviews[Revi] := 0;
          Application.ProcessMessages;
          exit;
       end;

       MapRec := Maps[i];
       if (MapRec.MinX < MaxX) and (MapRec.MinY < MaxY) and
          (MapRec.MaxX > MinX) and (MapRec.MaxY > MinY)then
       begin
          S := MapDirectory + MapRec.MapName;
          try
          if not compact then
             Image.Bitmap.Canvas.BeginScene;
          Bm1 := TBitmap.CreateFromFile(S);
          SrcRect  := TRectF.Create(0,0,Bm1.Width,Bm1.Height);
          DestRect := TRectF.Create(GetPageX(MapRec.MinX),GetPageY(MapRec.MaxY),GetPageX(MapRec.MaxX),GetPageY(MapRec.MinY));
          Image.Bitmap.Canvas.DrawBitmap(Bm1,SrcRect,DestRect,100);
          if not Compact then
          begin
             Image.Bitmap.Canvas.EndScene;
             Application.ProcessMessages;
          end;
          Bm1.DisposeOf;
          //PictureBox1.Image := System.Drawing.Bitmap.Create(S);
          finally
             //G.Dispose;
          end;
       end;
    end;
    Reviews[Revi] := 0;
    if Compact then
    begin
       Image.Bitmap.Canvas.EndScene;
       Application.ProcessMessages;
    end;

   DrawGPS;
end;

procedure TMainForm.set_GPSFixed(const Value: boolean);
begin
  FGPSFixed := Value;
end;

procedure TMainForm.ShowTheForest;
begin

end;

function TMainForm.StopReviews: integer;
var
   i,ii: integer;
   val: integer;
begin
   result := 0;
   ii := 0;
   for i := 0 to Length(Reviews) - 1 do
   begin
      val := Reviews[i];
      if val = 0 then
         result := i
      else
      if val = 1 then
      begin
         Reviews[i] := 2;
         ii := ii + 1;
      end;
   end;
//   l_Coords.Text := ii.ToString;
end;

end.
